diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-operating-channel.h ns-3.43/src/wifi/model/wifi-phy-operating-channel.h
--- ns-3.42/src/wifi/model/wifi-phy-operating-channel.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-operating-channel.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2021
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Stefano Avallone <stavallo@unina.it>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -22,21 +11,47 @@
 #define WIFI_PHY_OPERATING_CHANNEL_H
 
 #include "wifi-phy-band.h"
-#include "wifi-standards.h"
+#include "wifi-phy-common.h"
 
 #include "ns3/he-ru.h"
 
+#include <optional>
 #include <set>
 #include <tuple>
+#include <vector>
 
 namespace ns3
 {
 
 /**
- * A tuple (number, frequency, width, type, band) identifying a frequency channel
+ * A structure containing the information about a frequency channel
+ */
+struct FrequencyChannelInfo
+{
+    /**
+     * \brief spaceship operator.
+     *
+     * \param info the frequency channel info
+     * \returns -1 if the provided channel info is located at a lower channel number, 0 if the
+     * provided channel info is identical or 1 if the provided channel info is located at a higher
+     * channel number
+     */
+    auto operator<=>(const FrequencyChannelInfo& info) const = default;
+    uint8_t number{0};                                        ///< the channel number
+    MHz_u frequency{0};                                       ///< the center frequency
+    MHz_u width{0};                                           ///< the channel width
+    WifiPhyBand band{WifiPhyBand::WIFI_PHY_BAND_UNSPECIFIED}; ///< the PHY band
+    FrequencyChannelType type{FrequencyChannelType::OFDM};    ///< the frequency channel type
+};
+
+/**
+ * \brief Stream insertion operator.
+ *
+ * \param os the stream
+ * \param info the frequency channel info
+ * \returns a reference to the stream
  */
-typedef std::tuple<uint8_t, uint16_t, uint16_t, FrequencyChannelType, WifiPhyBand>
-    FrequencyChannelInfo;
+std::ostream& operator<<(std::ostream& os, const FrequencyChannelInfo& info);
 
 /**
  * \ingroup wifi
@@ -47,7 +62,24 @@
 {
   public:
     /// Typedef for a const iterator pointing to a channel in the set of available channels
-    typedef std::set<FrequencyChannelInfo>::const_iterator ConstIterator;
+    using ConstIterator = std::set<FrequencyChannelInfo>::const_iterator;
+
+    /// Comparison functor used to sort the segments by increasing frequencies
+    struct Compare
+    {
+        /**
+         * Functional operator for sorting the frequency segments.
+         *
+         * \param a const iterator pointing to the frequency channel for the first segment
+         * \param b const iterator pointing to the frequency channel for the second segment
+         * \return true if the center frequency of the first segment is lower than the center
+         * frequency of the second segment
+         */
+        bool operator()(const ConstIterator& a, const ConstIterator& b) const;
+    };
+
+    /// Typedef for a set of const iterator pointing to the segments of a channel
+    using ConstIteratorSet = std::set<ConstIterator, Compare>;
 
     /**
      * Create an uninitialized PHY operating channel.
@@ -62,6 +94,14 @@
      */
     WifiPhyOperatingChannel(ConstIterator it);
 
+    /**
+     * Create a PHY operating channel from iterators pointing to multiple frequency segments in the
+     * set of available channels.
+     *
+     * \param its the iterators pointing to frequency segments in the set of available channels
+     */
+    WifiPhyOperatingChannel(const ConstIteratorSet& its);
+
     virtual ~WifiPhyOperatingChannel();
 
     /**
@@ -101,57 +141,102 @@
      * If the channel width is a multiple of 20 MHz, the primary 20 MHz channel
      * is set to the 20 MHz subchannel with the lowest center frequency.
      *
-     * \param number the channel number (use 0 to leave it unspecified)
-     * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
-     * \param width the channel width in MHz (use 0 to leave it unspecified)
+     * \param segments the frequency segments
      * \param standard the standard
-     * \param band the PHY band
      */
-    void Set(uint8_t number,
-             uint16_t frequency,
-             uint16_t width,
-             WifiStandard standard,
-             WifiPhyBand band);
+    void Set(const std::vector<FrequencyChannelInfo>& segments, WifiStandard standard);
     /**
      * Set the default channel of the given width and for the given standard and band.
      * If the channel width is a multiple of 20 MHz, the primary 20 MHz channel
      * is set to the 20 MHz subchannel with the lowest center frequency.
      *
-     * \param width the channel width in MHz
+     * \param width the channel width
      * \param standard the standard
      * \param band the PHY band
      */
-    void SetDefault(uint16_t width, WifiStandard standard, WifiPhyBand band);
+    void SetDefault(MHz_u width, WifiStandard standard, WifiPhyBand band);
 
     /**
-     * Get the default channel number of the given width and for the given standard
-     * and band.
+     * Get the default channel number for a given segment of the given width and for the given
+     * standard and band.
      *
-     * \param width the channel width in MHz
+     * \param width the channel width
      * \param standard the standard
      * \param band the PHY band
+     * \param previousChannelNumber the channel number of the previous (in frequency) segment (if
+     * non-contiguous operating channel is used). If there is no place for another segment that is
+     * not contiguous to that previous one (at a higher frequency), an error is thrown
      * \return the default channel number
      */
-    static uint8_t GetDefaultChannelNumber(uint16_t width, WifiStandard standard, WifiPhyBand band);
+    static uint8_t GetDefaultChannelNumber(
+        MHz_u width,
+        WifiStandard standard,
+        WifiPhyBand band,
+        std::optional<uint8_t> previousChannelNumber = std::nullopt);
 
     /**
-     * Return the channel number identifying the whole operating channel.
+     * Return the channel number for a given frequency segment.
+     * Segments are ordered by increasing frequencies, hence by default
+     * it returns the channel number of the segment occuping the lowest
+     * frequencies when a non-contiguous operating channel is used.
      *
-     * \return the channel number identifying the whole operating channel
+     * \param segment the index of the frequency segment (if operating channel is non-contiguous)
+     * \return the channel number for a given frequency segment
      */
-    uint8_t GetNumber() const;
+    uint8_t GetNumber(std::size_t segment = 0) const;
     /**
-     * Return the center frequency of the operating channel (in MHz).
+     * Return the center frequency for a given frequency segment.
+     * Segments are ordered by increasing frequencies, hence by default
+     * it returns the center frequency of the segment occuping the lowest
+     * frequencies when a non-contiguous operating channel is used.
      *
-     * \return the center frequency of the operating channel (in MHz)
+     * \param segment the index of the frequency segment (if operating channel is non-contiguous)
+     * \return the center frequency for a given frequency segment
      */
-    uint16_t GetFrequency() const;
+    MHz_u GetFrequency(std::size_t segment = 0) const;
     /**
-     * Return the width of the whole operating channel (in MHz).
+     * Return the channel width for a given frequency segment.
+     * Segments are ordered by increasing frequencies, hence by default
+     * it returns the channel width of the segment occuping the lowest
+     * frequencies when a non-contiguous operating channel is used.
      *
-     * \return the width of the whole operating channel (in MHz)
+     * \param segment the index of the frequency segment (if operating channel is non-contiguous)
+     * \return the channel width for a given frequency segment
      */
-    uint16_t GetWidth() const;
+    MHz_u GetWidth(std::size_t segment = 0) const;
+    /**
+     * Return the width of the whole operating channel.
+     *
+     * \return the width of the whole operating channel
+     */
+    MHz_u GetTotalWidth() const;
+    /**
+     * Return the channel number per segment.
+     * Segments are ordered by increasing frequencies.
+     *
+     * \return the channel number per segment
+     */
+    std::vector<uint8_t> GetNumbers() const;
+    /**
+     * Return the center frequency per segment.
+     * Segments are ordered by increasing frequencies.
+     *
+     * \return the center frequency per segment
+     */
+    std::vector<MHz_u> GetFrequencies() const;
+    /**
+     * Return the channel width per segment.
+     * Segments are ordered by increasing frequencies.
+     *
+     * \return the channel width per segment
+     */
+    std::vector<MHz_u> GetWidths() const;
+    /**
+     * Return the width type of the operating channel.
+     *
+     * \return the width type of the operating channel
+     */
+    WifiChannelWidthType GetWidthType() const;
     /**
      * Return the PHY band of the operating channel
      *
@@ -182,24 +267,24 @@
      * primary channel of the given width within the operating channel (0 indicates
      * the 20 MHz subchannel with the lowest center frequency). Otherwise, return 0.
      *
-     * \param primaryChannelWidth the width of the primary channel in MHz
+     * \param primaryChannelWidth the width of the primary channel
      * \return the index of the requested primary channel within the operating channel
      */
-    uint8_t GetPrimaryChannelIndex(uint16_t primaryChannelWidth) const;
+    uint8_t GetPrimaryChannelIndex(MHz_u primaryChannelWidth) const;
 
     /**
      * If the operating channel width is made of a multiple of 20 MHz, return the index of the
      * secondary channel of the given width within the operating channel (0 indicates
      * the 20 MHz subchannel with the lowest center frequency). Otherwise, return 0.
      *
-     * \param secondaryChannelWidth the width of the secondary channel in MHz
+     * \param secondaryChannelWidth the width of the secondary channel
      * \return the index of the requested secondary channel within the operating channel
      */
-    uint8_t GetSecondaryChannelIndex(uint16_t secondaryChannelWidth) const;
+    uint8_t GetSecondaryChannelIndex(MHz_u secondaryChannelWidth) const;
 
     /**
      * Set the index of the primary 20 MHz channel (0 indicates the 20 MHz subchannel
-     * with the lowest center frequency).
+     * with the lowest center frequency among all segments).
      *
      * \param index the index of the primary 20 MHz channel
      */
@@ -208,41 +293,41 @@
     /**
      * Get the center frequency of the primary channel of the given width.
      *
-     * \param primaryChannelWidth the width of the primary channel in MHz
+     * \param primaryChannelWidth the width of the primary channel
      * \return the center frequency of the primary channel of the given width
      */
-    uint16_t GetPrimaryChannelCenterFrequency(uint16_t primaryChannelWidth) const;
+    MHz_u GetPrimaryChannelCenterFrequency(MHz_u primaryChannelWidth) const;
 
     /**
      * Get the center frequency of the secondary channel of the given width.
      *
-     * \param secondaryChannelWidth the width of the secondary channel in MHz
+     * \param secondaryChannelWidth the width of the secondary channel
      * \return the center frequency of the secondary channel of the given width
      */
-    uint16_t GetSecondaryChannelCenterFrequency(uint16_t secondaryChannelWidth) const;
+    MHz_u GetSecondaryChannelCenterFrequency(MHz_u secondaryChannelWidth) const;
 
     /**
      * Get the channel indices of all the 20 MHz channels included in the primary
      * channel of the given width, if such primary channel exists, or an empty set,
      * otherwise.
      *
-     * \param width the width in MHz of the primary channel
+     * \param width the width of the primary channel
      * \return the channel indices of all the 20 MHz channels included in the primary
      *         channel of the given width, if such primary channel exists, or an empty set,
      *         otherwise
      */
-    std::set<uint8_t> GetAll20MHzChannelIndicesInPrimary(uint16_t width) const;
+    std::set<uint8_t> GetAll20MHzChannelIndicesInPrimary(MHz_u width) const;
     /**
      * Get the channel indices of all the 20 MHz channels included in the secondary
      * channel of the given width, if such secondary channel exists, or an empty set,
      * otherwise.
      *
-     * \param width the width in MHz of the secondary channel
+     * \param width the width of the secondary channel
      * \return the channel indices of all the 20 MHz channels included in the secondary
      *         channel of the given width, if such secondary channel exists, or an empty set,
      *         otherwise
      */
-    std::set<uint8_t> GetAll20MHzChannelIndicesInSecondary(uint16_t width) const;
+    std::set<uint8_t> GetAll20MHzChannelIndicesInSecondary(MHz_u width) const;
     /**
      * Get the channel indices of all the 20 MHz channels included in the secondary
      * channel corresponding to the given primary channel, if such secondary channel
@@ -258,11 +343,11 @@
         const std::set<uint8_t>& primaryIndices) const;
 
     /**
-     * Find the first channel matching the specified parameters.
+     * Find the first frequency segment matching the specified parameters.
      *
      * \param number the channel number (use 0 to leave it unspecified)
      * \param frequency the channel center frequency in MHz (use 0 to leave it unspecified)
-     * \param width the channel width in MHz (use 0 to leave it unspecified)
+     * \param width the channel width (use 0 to leave it unspecified)
      * \param standard the standard (use WIFI_STANDARD_UNSPECIFIED not to check whether a
      *                 channel is suitable for a specific standard)
      * \param band the PHY band
@@ -271,35 +356,68 @@
      *         of the set of available channels
      */
     static ConstIterator FindFirst(uint8_t number,
-                                   uint16_t frequency,
-                                   uint16_t width,
+                                   MHz_u frequency,
+                                   MHz_u width,
                                    WifiStandard standard,
                                    WifiPhyBand band,
                                    ConstIterator start = m_frequencyChannels.begin());
 
     /**
      * Get channel number of the primary channel
-     * \param primaryChannelWidth the width of the primary channel (MHz)
+     * \param primaryChannelWidth the width of the primary channel
      * \param standard the standard
      *
      * \return channel number of the primary channel
      */
-    uint8_t GetPrimaryChannelNumber(uint16_t primaryChannelWidth, WifiStandard standard) const;
+    uint8_t GetPrimaryChannelNumber(MHz_u primaryChannelWidth, WifiStandard standard) const;
+
+    /**
+     * Get a WifiPhyOperatingChannel object corresponding to the primary channel of the given width.
+     *
+     * \param primaryChannelWidth the width of the primary channel in MHz
+     * \return a WifiPhyOperatingChannel object corresponding to the primary channel of the given
+     *         width
+     */
+    WifiPhyOperatingChannel GetPrimaryChannel(MHz_u primaryChannelWidth) const;
 
     /**
      * Get the channel indices of the minimum subset of 20 MHz channels containing the given RU.
      *
      * \param ru the given RU
-     * \param width the width in MHz of the channel to which the given RU refers to; normally,
-     *              it is the width in MHz of the PPDU for which the RU is allocated
+     * \param width the width of the channel to which the given RU refers to; normally,
+     *              it is the width of the PPDU for which the RU is allocated
      * \return the channel indices of the minimum subset of 20 MHz channels containing the given RU
      */
-    std::set<uint8_t> Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, uint16_t width) const;
+    std::set<uint8_t> Get20MHzIndicesCoveringRu(HeRu::RuSpec ru, MHz_u width) const;
+
+    /**
+     * Get the index of the segment that contains a given primary channel.
+     *
+     * \param primaryChannelWidth the width of the primary channel
+     * \return the index of the segment that contains the primary channel
+     */
+    uint8_t GetPrimarySegmentIndex(MHz_u primaryChannelWidth) const;
+
+    /**
+     * Get the index of the segment that contains a given secondary channel.
+     *
+     * \param secondaryChannelWidth the width of the secondary channel
+     * \return the index of the segment that contains the secondary channel
+     */
+    uint8_t GetSecondarySegmentIndex(MHz_u secondaryChannelWidth) const;
+
+    /**
+     * Get the number of frequency segments in the operating channel.
+     * This is only more than one if a non-contiguous operating channel is used.
+     *
+     * \return the number of frequency segments
+     */
+    std::size_t GetNSegments() const;
 
   private:
-    ConstIterator m_channelIt; //!< const iterator pointing to the configured frequency channel
-    uint8_t m_primary20Index;  /**< index of the primary20 channel (0 indicates the 20 MHz
-                                    subchannel with the lowest center frequency) */
+    ConstIteratorSet m_channelIts; //!< const iterators pointing to the configured frequency channel
+    uint8_t m_primary20Index;      /**< index of the primary20 channel (0 indicates the 20 MHz
+                                        subchannel with the lowest center frequency) */
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-state.h ns-3.43/src/wifi/model/wifi-phy-state.h
--- ns-3.42/src/wifi/model/wifi-phy-state.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-state.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Sébastien Deronne <sebastien.deronne@gmail.com>
@@ -97,21 +86,26 @@
 
 } // namespace ns3
 
+/**
+ * Deprecated WifiPhyState enums.
+ *
+ * Use WifiPhyState class enum symbols instead.
+ * @{
+ */
 NS_DEPRECATED_3_42("Use WifiPhyState::IDLE instead")
-static constexpr auto IDLE = ns3::WifiPhyState::IDLE; //!< \deprecated See WifiPhyState::IDLE
+static constexpr auto IDLE = ns3::WifiPhyState::IDLE;
 NS_DEPRECATED_3_42("Use WifiPhyState::CCA_BUSY instead")
-static constexpr auto CCA_BUSY =
-    ns3::WifiPhyState::CCA_BUSY; //!< \deprecated See WifiPhyState::CCA_BUSY
+static constexpr auto CCA_BUSY = ns3::WifiPhyState::CCA_BUSY;
 NS_DEPRECATED_3_42("Use WifiPhyState::TX instead")
-static constexpr auto TX = ns3::WifiPhyState::TX; //!< \deprecated See WifiPhyState::TX
+static constexpr auto TX = ns3::WifiPhyState::TX;
 NS_DEPRECATED_3_42("Use WifiPhyState::RX instead")
-static constexpr auto RX = ns3::WifiPhyState::RX; //!< \deprecated See WifiPhyState::RX
+static constexpr auto RX = ns3::WifiPhyState::RX;
 NS_DEPRECATED_3_42("Use WifiPhyState::SWITCHING instead")
-static constexpr auto SWITCHING =
-    ns3::WifiPhyState::SWITCHING; //!< \deprecated See WifiPhyState::SWITCHING
+static constexpr auto SWITCHING = ns3::WifiPhyState::SWITCHING;
 NS_DEPRECATED_3_42("Use WifiPhyState::SLEEP instead")
-static constexpr auto SLEEP = ns3::WifiPhyState::SLEEP; //!< \deprecated See WifiPhyState::SLEEP
+static constexpr auto SLEEP = ns3::WifiPhyState::SLEEP;
 NS_DEPRECATED_3_42("Use WifiPhyState::OFF instead")
-static constexpr auto OFF = ns3::WifiPhyState::OFF; //!< \deprecated See WifiPhyState::OFF
+static constexpr auto OFF = ns3::WifiPhyState::OFF;
+/**@}*/
 
 #endif /* WIFI_PHY_STATE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-state-helper.cc ns-3.43/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.42/src/wifi/model/wifi-phy-state-helper.cc	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-state-helper.cc	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -320,11 +309,11 @@
 
 void
 WifiPhyStateHelper::SwitchToTx(Time txDuration,
-                               WifiConstPsduMap psdus,
-                               double txPowerDbm,
+                               const WifiConstPsduMap& psdus,
+                               dBm_u txPower,
                                const WifiTxVector& txVector)
 {
-    NS_LOG_FUNCTION(this << txDuration << psdus << txPowerDbm << txVector);
+    NS_LOG_FUNCTION(this << txDuration << psdus << txPower << txVector);
     if (!m_txTrace.IsEmpty())
     {
         for (const auto& psdu : psdus)
@@ -335,7 +324,7 @@
                       txVector.GetTxPowerLevel());
         }
     }
-    Time now = Simulator::Now();
+    const auto now = Simulator::Now();
     switch (GetState())
     {
     case WifiPhyState::RX:
@@ -358,7 +347,7 @@
     m_previousStateChangeTime = now;
     m_endTx = now + txDuration;
     m_startTx = now;
-    NotifyListeners(&WifiPhyListener::NotifyTxStart, txDuration, txPowerDbm);
+    NotifyListeners(&WifiPhyListener::NotifyTxStart, txDuration, txPower);
 }
 
 void
@@ -404,6 +393,9 @@
     case WifiPhyState::IDLE:
         LogPreviousIdleAndCcaBusyStates();
         break;
+    case WifiPhyState::SWITCHING:
+        // do nothing
+        break;
     default:
         NS_FATAL_ERROR("Invalid WifiPhy state.");
         break;
@@ -573,7 +565,7 @@
 }
 
 void
-WifiPhyStateHelper::SwitchFromRxAbort(uint16_t operatingWidth)
+WifiPhyStateHelper::SwitchFromRxAbort(MHz_u operatingWidth)
 {
     NS_LOG_FUNCTION(this << operatingWidth);
     NS_ASSERT(IsStateCcaBusy()); // abort is called (with OBSS_PD_CCA_RESET reason) before RX is set
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/wifi-phy-state-helper.h ns-3.43/src/wifi/model/wifi-phy-state-helper.h
--- ns-3.42/src/wifi/model/wifi-phy-state-helper.h	2024-05-29 15:29:47.212073800 -0700
+++ ns-3.43/src/wifi/model/wifi-phy-state-helper.h	2024-10-09 16:41:10.132656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2005,2006 INRIA
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
@@ -182,12 +171,12 @@
      *
      * \param txDuration the duration of the PPDU to transmit
      * \param psdus the PSDUs in the transmitted PPDU (only one unless it is a MU PPDU)
-     * \param txPowerDbm the nominal TX power in dBm
+     * \param txPower the nominal TX power
      * \param txVector the TX vector for the transmission
      */
     void SwitchToTx(Time txDuration,
-                    WifiConstPsduMap psdus,
-                    double txPowerDbm,
+                    const WifiConstPsduMap& psdus,
+                    dBm_u txPower,
                     const WifiTxVector& txVector);
     /**
      * Switch state to RX for the given duration.
@@ -257,9 +246,9 @@
     void SwitchFromRxEndError();
     /**
      * Abort current reception following a CCA reset request.
-     * \param operatingWidth the channel width the PHY is operating on (in MHz)
+     * \param operatingWidth the channel width the PHY is operating on
      */
-    void SwitchFromRxAbort(uint16_t operatingWidth);
+    void SwitchFromRxAbort(MHz_u operatingWidth);
     /**
      * Switch to CCA busy.
      *
